export = TestSuite;
declare function TestSuite(fileId: number | string, opt_sourceEncoding?: string): void;
declare class TestSuite {
    constructor(fileId: number | string, opt_sourceEncoding?: string);
    key: number | null;
    version: number | null;
    private type_;
    filePath: string;
    name: string;
    private fileId_;
    private sourceEncoding_;
    getFileId(): string | number;
    getSourceEncoding(): string;
    private _testsByName;
    private _tests;
    type: number;
    getId(): string;
    private getUfsTestType_;
    private displayStringForValue_;
    private fail_;
    private argumentsIncludeComments_;
    private commentArg_;
    private nonCommentArg_;
    private validateArguments_;
    private assert_;
    declareTestMethods(): void;
    deleteTestMethods(): void;
    isTestCase(methodName: any): boolean;
    getTests(): any[];
    getTestByName(name: any): any;
    update(): void;
    setUp(): void;
    tearDown(): void;
    fail(msg: string): never;
    failEquals(expected: any, actual: any, msg: any): void;
    failNotEquals(expected: any, actual: any, msg: any): void;
    check(condition: any, msg: any): void;
    checkEquals(expected: any, actual: any, msg: any): void;
    checkNotEquals(expected: any, actual: any, msg: any): void;
    checkEqualNumbers(expected: any, actual: any, delta: any, msg: any): void;
    checkNotEqualNumbers(expected: any, actual: any, delta: any, msg: any): void;
    removeTime(dt: Date): Date;
    checkEqualDates(expected: any, actual: any, msg: any): void;
    checkNotEqualDates(expected: any, actual: any, msg: any): void;
    checkEqualDateTimes(expected: any, actual: any, msg: any): void;
    checkNotEqualDateTimes(expected: any, actual: any, msg: any): void;
    isEqualArrays(ar1: any, ar2: any): boolean;
    checkEqualArrays(expected: any, actual: any, msg: any): void;
    checkNotEqualArrays(expected: any, actual: any, msg: any): void;
    assert(message: any, condition: any, ...args: any[]): void;
    assertTrue(...args: any[]): void;
    assertFalse(...args: any[]): void;
    assertEquals(...args: any[]): void;
    assertNotEquals(...args: any[]): void;
    assertNull(...args: any[]): void;
    assertNotNull(...args: any[]): void;
    assertUndefined(...args: any[]): void;
    assertNotUndefined(...args: any[]): void;
    assertNan(...args: any[]): void;
    assertNotNan(...args: any[]): void;
}
